package com.espectaclia.converters;

import javax.faces.component.UIComponent;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.servlet.ServletContext;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.context.support.WebApplicationContextUtils;

import com.espectaclia.daos.ClientDAO;
import com.espectaclia.entities.Client;

@FacesConverter("clientConverter")
public class ClientConverter implements Converter{

	@Autowired
	private ClientDAO clientDAO;
	
	public ClientConverter() {
		// Importem l'Autowired (Spring) al FacesConverter (JSF) per poder injectar els DAOs
		ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
        ServletContext servletContext = (ServletContext) externalContext.getContext();
        WebApplicationContextUtils.getRequiredWebApplicationContext(servletContext).getAutowireCapableBeanFactory().autowireBean(this);
	}
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {

		if (value == null || value.length() == 0) return null;
	    
		try {
			Integer id = Integer.parseInt(value);
			return clientDAO.cercarPerId(id);
		} catch (Exception e) {
			return null;
		}
		
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object value) {

		if (value == null) return null;
		
		return value instanceof Client ? ((Client) value).getId().toString() : "";
		
	}	
}