package com.espectaclia.converters;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
 
@FacesConverter("duracioConverter")
public class DuracioConverter implements Converter{

	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {

		return value;
		
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object value) {

		String duracio = value.toString();
		
		// Si la duració no és buïda i és un número
		if (duracio != null && !duracio.isEmpty() && duracio.matches("\\d+")) {
			// La duració ve en número de minuts, la formategem
			int hores = Integer.parseInt(duracio) / 60;
			int minuts = Integer.parseInt(duracio) % 60;

			duracio = hores+"h"+(minuts > 0 ? " "+minuts+"m" : "");
		}
		
		return duracio;
		
	}	
}
