package com.espectaclia.converters;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.espectaclia.daos.RecinteDAO;
import com.espectaclia.entities.Recinte;

@Service
@FacesConverter("recinteConverter")
public class RecinteConverter implements Converter{

	@Autowired
	private RecinteDAO recinteDAO;
	
	@Override
	public Object getAsObject(FacesContext context, UIComponent component, String value) {

		if (value == null || value.length() == 0) return null;
	    
		try {
			Integer id = Integer.parseInt(value);
			return recinteDAO.cercarPerId(id);
		} catch (Exception e) {
			return null;
		}
		
	}

	@Override
	public String getAsString(FacesContext context, UIComponent component, Object value) {

		if (value == null) return null;
		
		return value instanceof Recinte ? ((Recinte) value).getId().toString() : "";
		
	}	
}