package com.espectaclia.entities;

import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.PrimaryKeyJoinColumn;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

import com.espectaclia.enumerations.EstatReserva;

@Entity(name = "Client")
@PrimaryKeyJoinColumn(name="id")
@NamedQueries({
@NamedQuery(name="Client.findAll",query="SELECT c FROM Client c")})
public class Client extends Usuari {
	
	@Column(name="email",nullable=false,unique=true,length=40)
    private String email;
    
    @Column(name="telefon",nullable=true,length=9)
    private Integer telefon;
    
    @Column(name="adreca",nullable=true,length=80)
    private String adreca;
    
    @Column(name="dataNaixement",nullable=true)
    private Date dataNaixement;
    
    @OneToMany(cascade=CascadeType.ALL,mappedBy="client",orphanRemoval=true)
   	@LazyCollection(LazyCollectionOption.FALSE)
   	private List<Reserva> reserves;
    
    @OneToMany(cascade=CascadeType.ALL,mappedBy="client",orphanRemoval=true)
   	@LazyCollection(LazyCollectionOption.FALSE)
   	private List<Valoracio> valoracions;
    
    public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Integer getTelefon() {
		return telefon;
	}

	public void setTelefon(Integer telefon) {
		this.telefon = telefon;
	}

	public String getAdreca() {
		return adreca;
	}

	public void setAdreca(String adreca) {
		this.adreca = adreca;
	}

	public Date getDataNaixement() {
		return dataNaixement;
	}

	public void setDataNaixement(Date dataNaixement) {
		this.dataNaixement = dataNaixement;
	}
	
	public List<Reserva> getReserves() {
		return reserves;
	}

	public void setReserves(List<Reserva> reserves) {
		this.reserves = reserves;
	}

	public List<Valoracio> getValoracions() {
		return valoracions;
	}

	public void setValoracions(List<Valoracio> valoracions) {
		this.valoracions = valoracions;
	}
	
	public boolean teReservesPendents() {
		if (reserves.size() > 0) {
			for (Reserva reserva : reserves) {
				if (reserva.getEstat() == EstatReserva.CONFIRMADA) return true;
			}
		}
		return false;
	}

}