package com.espectaclia.entities;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

import com.espectaclia.enumerations.TipusDescompte;

@Entity(name = "Descompte")
@NamedQueries({
@NamedQuery(name="Descompte.findAll",query="SELECT d FROM Descompte d")})
public class Descompte {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="id",nullable=false)
    private int id;
	
	@Column(name="nom",nullable=false,length=30)
    private String nom;
	
    @Enumerated(EnumType.ORDINAL)
    @Column(name="tipus",nullable=false)
    private TipusDescompte tipus;
    
    @Column(name="percDescompte",nullable=false)
    private Double percDescompte;
    
    @Column(name="dataInici",nullable=true)
    private Date dataInici;
	
    @Column(name="dataFi",nullable=true)
    private Date dataFi;
    
    @ManyToOne 
    @JoinColumn(name="idEspectacle")
 	private Espectacle espectacle;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public TipusDescompte getTipus() {
		return tipus;
	}

	public void setTipus(TipusDescompte tipus) {
		this.tipus = tipus;
	}

	public Double getPercDescompte() {
		return percDescompte;
	}

	public void setPercDescompte(Double percDescompte) {
		this.percDescompte = percDescompte;
	}

	public Date getDataInici() {
		return dataInici;
	}

	public void setDataInici(Date dataInici) {
		this.dataInici = dataInici;
	}

	public Date getDataFi() {
		return dataFi;
	}

	public void setDataFi(Date dataFi) {
		this.dataFi = dataFi;
	}

	public Espectacle getEspectacle() {
		return espectacle;
	}

	public void setEspectacle(Espectacle espectacle) {
		this.espectacle = espectacle;
	}
	
	public String getDescripcioTipus() {
		switch(tipus) {
		case PACK_ENTRADES:
			return "Pack entrades";
		case FAMILIA_NOMBROSA:
			return "Família nombrosa";
		case SESSIO_GOLFA:
			return "Sessió golfa";
		case SESSIO_ESPECIAL:
			return "Sessió especial";
		case DIA_ESPECTADOR:
			return "Dia espectador";
		case DISCAPACITAT:
			return "Discapacitat";
		case CARNET_DESCOMPTE:
			return "Carnet descompte";
		case INFANTIL:
			return "Infantil";
		case JOVE:
			return "Jove";
		case JUBILAT:
			return "Jubilat";
		default:
			return "";
		}
	}
    
}