package com.espectaclia.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

@Entity(name = "Localitat")
@NamedQueries({
@NamedQuery(name="Localitat.findAll",query="SELECT l FROM Localitat l")})
public class Localitat {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="id",nullable=false)
    private int id;
	
	@ManyToOne
	@JoinColumn(name="idZona",nullable=false)
	private Zona zona;
	
	@ManyToOne
	@JoinColumn(name="idReserva",nullable=false)
	private Reserva reserva;
	
	@Column(name="fila",nullable=false)
    private int fila;
	
	@Column(name="seient",nullable=false)
    private int seient;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Zona getZona() {
		return zona;
	}

	public void setZona(Zona zona) {
		this.zona = zona;
	}

	public Reserva getReserva() {
		return reserva;
	}

	public void setReserva(Reserva reserva) {
		this.reserva = reserva;
	}

	public int getFila() {
		return fila;
	}

	public void setFila(int fila) {
		this.fila = fila;
	}

	public int getSeient() {
		return seient;
	}

	public void setSeient(int seient) {
		this.seient = seient;
	}
	
	@Override
    public int hashCode() {
        return new HashCodeBuilder(7, 13).
            append(id).
            append(zona.getId()).
            append(fila).
            append(seient).
            toHashCode();
    }
	
	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj == null || obj.getClass() != this.getClass()) {
			return false;
		}
		
		Localitat loc = (Localitat) obj;
		return new EqualsBuilder().
            append(id, loc.id).
            append(zona.getId(), loc.zona.getId()).
            append(fila, loc.fila).
            append(seient, loc.seient).
            isEquals();
	}
	
}