package com.espectaclia.entities;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

@Entity(name = "Usuari")
@Inheritance(strategy=InheritanceType.JOINED)
@NamedQueries({
@NamedQuery(name="Usuari.findAll",query="SELECT u FROM Usuari u")})
public class Usuari {

    @Id
	@GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="id",nullable=false)
    private Integer id;
    
    @Column(name="nif",nullable=false,length=50)
    private String nif;

    @Column(name="nom",nullable=false,length=30)
    private String nom;
    
    @Column(name="cognoms",nullable=false,length=60)
    private String cognoms;
    
    @Column(name="username",nullable=false,unique=true,length=18)
    private String username;
    
    @Column(name="password",nullable=false,length=18)
    private String password;
    
    @Column(name="dataAlta",nullable=false)
    private Date dataAlta;
    
    @Column(name="dataUltModificacio",nullable=true)
    private Date dataUltModificacio;
    
    @Column(name="dataBaixa",nullable=true)
    private Date dataBaixa;

    public Integer getId() {
		return id;
	}
    
    public void setId(Integer id) {
		this.id = id;
	}
    
    public String getNif() {
		return nif;
	}

	public void setNif(String nif) {
		this.nif = nif;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognoms() {
		return cognoms;
	}

	public void setCognoms(String cognoms) {
		this.cognoms = cognoms;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public Date getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}

	public Date getDataUltModificacio() {
		return dataUltModificacio;
	}

	public void setDataUltModificacio(Date dataUltModificacio) {
		this.dataUltModificacio = dataUltModificacio;
	}

	public Date getDataBaixa() {
		return dataBaixa;
	}

	public void setDataBaixa(Date dataBaixa) {
		this.dataBaixa = dataBaixa;
	}
	
}