package com.espectaclia.entities;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

import com.espectaclia.enumerations.Puntuacio;

@Entity(name = "Valoracio")
@NamedQueries({
@NamedQuery(name="Valoracio.findAll",query="SELECT v FROM Valoracio v")})
public class Valoracio {
	
	@EmbeddedId
	protected ValoracioPK valoracioPK;

	@ManyToOne
	@JoinColumn(name="idClient",insertable=false,updatable=false)
	private Client client;
	
	@ManyToOne
	@JoinColumn(name="idEspectacle",insertable=false,updatable=false)
	private Espectacle espectacle;
	
	@Enumerated(EnumType.ORDINAL)
    @Column(name="puntuacio",nullable=false)
    private Puntuacio puntuacio;
	
	@Column(name="comentari",nullable=true)
    private String comentari;

	public ValoracioPK getValoracioPK() {
		return valoracioPK;
	}

	public void setValoracioPK(ValoracioPK valoracioPK) {
		this.valoracioPK = valoracioPK;
	}
	
	public Puntuacio getPuntuacio() {
		return puntuacio;
	}

	public void setPuntuacio(Puntuacio puntuacio) {
		this.puntuacio = puntuacio;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	public Client getClient() {
		return client;
	}

	public void setClient(Client client) {
		this.client = client;
	}

	public Espectacle getEspectacle() {
		return espectacle;
	}

	public void setEspectacle(Espectacle espectacle) {
		this.espectacle = espectacle;
	}
	
	public String getDescripcioPuntuacio() {
		switch(puntuacio) {
		case EXCELLENT:
			return "Excel·lent";
		case MOLT_BE:
			return "Molt bé";
		case BE:
			return "Bé";
		case REGULAR:
			return "Regular";
		case MALAMENT:
			return "Malament";
		default:
			return "";
		}
	}
	
}