package com.espectaclia.managed_beans;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

import org.primefaces.model.menu.DefaultMenuItem;
import org.primefaces.model.menu.DefaultMenuModel;
import org.primefaces.model.menu.MenuModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.context.support.WebApplicationContextUtils;

import com.espectaclia.daos.DescompteDAO;
import com.espectaclia.daos.EspectacleDAO;
import com.espectaclia.daos.FuncioDAO;
import com.espectaclia.daos.RecinteDAO;
import com.espectaclia.daos.ReservaDAO;
import com.espectaclia.daos.TaquillerDAO;
import com.espectaclia.daos.ZonaDAO;
import com.espectaclia.entities.Descompte;
import com.espectaclia.entities.Espectacle;
import com.espectaclia.entities.Funcio;
import com.espectaclia.entities.Recinte;
import com.espectaclia.entities.Reserva;
import com.espectaclia.entities.Taquiller;
import com.espectaclia.entities.Zona;

@ManagedBean(name="menuMB")
@SessionScoped
public class MenuMB implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
    private MenuModel model;
    private String menuActiu;
    
    @Autowired
	private TaquillerDAO taquillerDAO;
    
    @Autowired
   	private RecinteDAO recinteDAO;
    
    @Autowired
   	private ZonaDAO zonaDAO;
    
    @Autowired
   	private EspectacleDAO espectacleDAO;
    
    @Autowired
   	private FuncioDAO funcioDAO;
    
    @Autowired
   	private DescompteDAO descompteDAO;
    
    @Autowired
   	private ReservaDAO reservaDAO;

    @PostConstruct
    public void init() {
    	// Importem l'Autowired (Spring) al ManagedBean (JSF) per poder injectar els DAOs
		ExternalContext externalContext = FacesContext.getCurrentInstance().getExternalContext();
        ServletContext servletContext = (ServletContext) externalContext.getContext();
        WebApplicationContextUtils.getRequiredWebApplicationContext(servletContext).getAutowireCapableBeanFactory().autowireBean(this);
    	
    	model = new DefaultMenuModel();
    	
    	DefaultMenuItem menuItem = new DefaultMenuItem();
        menuItem.setValue("Inici");
        menuItem.setIcon("glyphicon glyphicon-home");
        menuItem.setUrl("/views/app/inici.xhtml?faces-redirect=true");
        model.addElement(menuItem);
    }

    public void actualitzarBreadcrumb(String destinacio, List<Object> params) {
    	// Inicialitzem el model de navegació i setegem el menu actiu
    	model = new DefaultMenuModel();
    	
    	DefaultMenuItem menuItem = new DefaultMenuItem();
        menuItem.setValue("Inici");
        menuItem.setIcon("glyphicon glyphicon-home");
        menuItem.setUrl("/views/app/inici.xhtml?faces-redirect=true");
        model.addElement(menuItem);
    	
        // Construim el model de navegació fins a la destinació
        // INICI
    	if (destinacio.equalsIgnoreCase("INICI")) {
    		menuActiu = "INICI";
    	// MODIFICAR CLIENT
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_CLIENT")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar perfil");
            menuItem.setUrl("/views/app/client/modificar_client.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "INICI";            
        // RESERVES
    	} else if (destinacio.equalsIgnoreCase("RESERVES")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar reserves");
            menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "RESERVES";
    	} else if (destinacio.equalsIgnoreCase("CERCAR_ESPECTACLES")) {
    		boolean desdeInici = (boolean) params.get(1);
    		
			if (desdeInici) {
                menuActiu = "INICI";
			} else {
				menuItem = new DefaultMenuItem();
                menuItem.setValue("Gestionar reserves");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
                menuItem.setValue("Nova reserva");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
				
				menuActiu = "RESERVES";
			}
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Cercar espectacle");
            menuItem.setUrl("/views/app/reserva/cercar_espectacles.xhtml?faces-redirect=true&novaReserva=true&desdeInici="+desdeInici);
            model.addElement(menuItem);
    	} else if (destinacio.equalsIgnoreCase("RESERVA_ESPECTACLE")) {
    		boolean novaReserva = (boolean) params.get(0);
    		boolean desdeInici = (boolean) params.get(1);
    		Integer idReserva = (Integer) params.get(2);
    		Integer idEspectacle = (Integer) params.get(3);
    		
    		Reserva reserva = new Reserva();
    		if (idReserva != null) {
    			try{
        			reserva = reservaDAO.cercarPerId(idReserva);
        		} catch (Exception e) {}
    		}
    		
    		Espectacle espectacle = new Espectacle();
    		if (idEspectacle != null) {
    			try{
        			espectacle = espectacleDAO.cercarPerId(idEspectacle);
        		} catch (Exception e) {}
    		}
    		
    		if (desdeInici) {
    			menuItem = new DefaultMenuItem();
	            menuItem.setValue("Cercar espectacle");
	            menuItem.setUrl("/views/app/reserva/cercar_espectacles.xhtml?faces-redirect=true&novaReserva=true&desdeInici=true");
	            model.addElement(menuItem);
	            
	            menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+espectacle.getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=true&desdeInici=true&idEspectacle="+idEspectacle);
	            model.addElement(menuItem);
	            
	            menuActiu = "INICI";
    		} else if (novaReserva) {
    			menuItem = new DefaultMenuItem();
                menuItem.setValue("Gestionar reserves");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
                menuItem.setValue("Nova reserva");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+espectacle.getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=true&desdeInici=false&idEspectacle="+idEspectacle);
	            model.addElement(menuItem);
    			
    			menuActiu = "RESERVES";
    		} else {
    			menuItem = new DefaultMenuItem();
                menuItem.setValue("Gestionar reserves");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
                menuItem.setValue("Modificar reserva");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+reserva.getFuncio().getEspectacle().getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=false&desdeInici=false&idReservaModificar="+idReserva);
	            model.addElement(menuItem);
    			
    			menuActiu = "RESERVES";
    		}
    	} else if (destinacio.equalsIgnoreCase("RESERVA_LOCALITATS")) {
    		boolean novaReserva = (boolean) params.get(0);
    		boolean desdeInici = (boolean) params.get(1);
    		Integer idReserva = (Integer) params.get(2);
    		Integer idEspectacle = (Integer) params.get(3);
    		Integer idFuncio = (Integer) params.get(4);
    		Integer idZona = (Integer) params.get(5);
    		Integer idClientReserva = (Integer) params.get(6);
    		
    		Reserva reserva = new Reserva();
    		if (idReserva != null) {
    			try{
        			reserva = reservaDAO.cercarPerId(idReserva);
        		} catch (Exception e) {}
    		}
    		
    		Espectacle espectacle = new Espectacle();
    		if (idEspectacle != null) {
    			try{
        			espectacle = espectacleDAO.cercarPerId(idEspectacle);
        		} catch (Exception e) {}
    		}
    		
    		Funcio funcio = new Funcio();
    		if (idFuncio != null) {
    			try{
        			funcio = funcioDAO.cercarPerId(idFuncio);
        		} catch (Exception e) {}
    		}
    		
    		if (desdeInici) {
    			menuItem = new DefaultMenuItem();
	            menuItem.setValue("Cercar espectacle");
	            menuItem.setUrl("/views/app/reserva/cercar_espectacles.xhtml?faces-redirect=true&novaReserva=true&desdeInici=true");
	            model.addElement(menuItem);
	            
	            menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+espectacle.getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=true&desdeInici=true&idEspectacle="+idEspectacle);
	            model.addElement(menuItem);
	            
	            menuItem = new DefaultMenuItem();
	            menuItem.setValue("Funció: "+funcio.getFormattedData());
	            String url = "/views/app/reserva/localitats.xhtml?faces-redirect=true&novaReserva=true&desdeInici=true&idEspectacle="+idEspectacle+"&idFuncio="+idFuncio;
	            if (idZona != null) url += "&idZona="+idZona;
	            if (idClientReserva != null) url += "&idClientReserva="+idClientReserva;
	            menuItem.setUrl(url);
	            model.addElement(menuItem);
	            
	            menuActiu = "INICI";
    		} else if (novaReserva) {
    			menuItem = new DefaultMenuItem();
                menuItem.setValue("Gestionar reserves");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
                menuItem.setValue("Nova reserva");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+espectacle.getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=true&desdeInici=false&idEspectacle="+idEspectacle);
	            model.addElement(menuItem);
	            
	            menuItem = new DefaultMenuItem();
	            menuItem.setValue("Funció: "+funcio.getFormattedData());
	            String url = "/views/app/reserva/localitats.xhtml?faces-redirect=true&novaReserva=true&desdeInici=false&idEspectacle="+idEspectacle+"&idFuncio="+idFuncio;
	            if (idZona != null) url += "&idZona="+idZona;
	            if (idClientReserva != null) url += "&idClientReserva="+idClientReserva;
	            menuItem.setUrl(url);
	            model.addElement(menuItem);
    			
    			menuActiu = "RESERVES";
    		} else {
    			menuItem = new DefaultMenuItem();
                menuItem.setValue("Gestionar reserves");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
                menuItem.setValue("Modificar reserva");
                menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
                model.addElement(menuItem);
                
                menuItem = new DefaultMenuItem();
	            menuItem.setValue("Espectacle: "+reserva.getFuncio().getEspectacle().getNom());
	            menuItem.setUrl("/views/app/reserva/espectacle.xhtml?faces-redirect=true&novaReserva=false&desdeInici=false&idReservaModificar="+idReserva);
	            model.addElement(menuItem);
	            
	            menuItem = new DefaultMenuItem();
	            menuItem.setValue("Funció: "+reserva.getFuncio().getFormattedData());
	            String url = "/views/app/reserva/localitats.xhtml?faces-redirect=true&novaReserva=false&desdeInici=false&idReservaModificar="+idReserva;
	            if (idClientReserva != null) url += "&idClientReserva="+idClientReserva;
	            menuItem.setUrl(url);
	            model.addElement(menuItem);
    			
    			menuActiu = "RESERVES";
    		}
    	} else if (destinacio.equalsIgnoreCase("RESERVA_CONFIRMACIO")) {
    		boolean novaReserva = (boolean) params.get(0);
    		Integer idReserva = (Integer) params.get(2);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar reserves");
            menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            if (novaReserva) {
            	menuItem = new DefaultMenuItem();
                menuItem.setValue("Reserva creada");
                menuItem.setUrl("/views/app/reserva/confirmacio.xhtml?faces-redirect=true&novaReserva=true&idReservaModificar="+idReserva);
                model.addElement(menuItem);
            } else {
            	menuItem = new DefaultMenuItem();
                menuItem.setValue("Reserva actualitzada");
                menuItem.setUrl("/views/app/reserva/confirmacio.xhtml?faces-redirect=true&novaReserva=false&idReservaModificar="+idReserva);
                model.addElement(menuItem);
            }
			
			menuActiu = "RESERVES";
    	} else if (destinacio.equalsIgnoreCase("RESERVA_VENDA")) {
    		Integer idReserva = (Integer) params.get(2);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar reserves");
            menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Vendre reserva");
            menuItem.setUrl("/views/app/reserva/vendre_reserva.xhtml?faces-redirect=true&idReservaModificar="+idReserva);
            model.addElement(menuItem);
			
			menuActiu = "RESERVES";
    	} else if (destinacio.equalsIgnoreCase("RESERVA_VALORACIO")) {
    		Integer idReserva = (Integer) params.get(2);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar reserves");
            menuItem.setUrl("/views/app/reserva/reserves.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Valorar espectacle");
            menuItem.setUrl("/views/app/reserva/valorar_espectacle.xhtml?faces-redirect=true&idReservaModificar="+idReserva);
            model.addElement(menuItem);
			
			menuActiu = "RESERVES";
        // TAQUILLERS
    	} else if (destinacio.equalsIgnoreCase("TAQUILLERS")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar taquillers");
            menuItem.setUrl("/views/app/taquiller/taquillers.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "TAQUILLERS";
    	} else if (destinacio.equalsIgnoreCase("NOU_TAQUILLER")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar taquillers");
            menuItem.setUrl("/views/app/taquiller/taquillers.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nou taquiller");
            menuItem.setUrl("/views/app/taquiller/modificar_taquiller.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "TAQUILLERS";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_TAQUILLER")) {
    		Taquiller taquiller = new Taquiller();
    		try{
    			taquiller = taquillerDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar taquillers");
            menuItem.setUrl("/views/app/taquiller/taquillers.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar taquiller: "+taquiller.getNom()+" "+taquiller.getCognoms());
            menuItem.setUrl("/views/app/taquiller/modificar_taquiller.xhtml?faces-redirect=true&idTaquillerModificar="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "TAQUILLERS";
        // RECINTES
    	} else if (destinacio.equalsIgnoreCase("RECINTES")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("NOU_RECINTE")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nou recinte");
            menuItem.setUrl("/views/app/recintes/modificar_recinte.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_RECINTE")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/modificar_recinte.xhtml?faces-redirect=true&idRecinteModificar="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // ZONES
    	} else if (destinacio.equalsIgnoreCase("ZONES")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar zones");
            menuItem.setUrl("/views/app/zona/zones.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("NOVA_ZONA")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar zones");
            menuItem.setUrl("/views/app/zones/zones.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nova zona");
            menuItem.setUrl("/views/app/zona/modificar_zona.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_ZONA")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Zona zona = new Zona();
    		try{
    			zona = zonaDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar zones");
            menuItem.setUrl("/views/app/zona/zones.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar zona: "+zona.getNom());
            menuItem.setUrl("/views/app/zona/modificar_zona.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idZonaModificar="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // ESPECTACLES
    	} else if (destinacio.equalsIgnoreCase("ESPECTACLES")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar espectacles");
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("NOU_ESPECTACLE")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar espectacles");
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nou espectacle");
            menuItem.setUrl("/views/app/espectacle/modificar_espectacle.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_ESPECTACLE")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar espectacles");
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/modificar_espectacle.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacleModificar="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // FUNCIONS
    	} else if (destinacio.equalsIgnoreCase("FUNCIONS")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar funcions");
            menuItem.setUrl("/views/app/funcio/funcions.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("NOVA_FUNCIO")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nova funció");
            menuItem.setUrl("/views/app/funcio/modificar_funcio.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_FUNCIO")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		Funcio funcio = new Funcio();
    		try{
    			funcio = funcioDAO.cercarPerId(params.get(2));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar funció: "+funcio.getFormattedData());
            menuItem.setUrl("/views/app/funcio/modificar_funcio.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1)+"&idFuncioModificar="+params.get(2));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // BLOQUEJAR LOCALITATS
    	} else if (destinacio.equalsIgnoreCase("BLOQUEJAR_LOCS")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		Funcio funcio = new Funcio();
    		try{
    			funcio = funcioDAO.cercarPerId(params.get(2));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Funció: "+funcio.getFormattedData());
            menuItem.setUrl("/views/app/funcio/funcions.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Bloquejar localitats");
            menuItem.setUrl("/views/app/funcio/funcions.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1)+"&idFuncioModificar="+params.get(2));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // DESCOMPTES
    	} else if (destinacio.equalsIgnoreCase("DESCOMPTES")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar descomptes");
            menuItem.setUrl("/views/app/descompte/descomptes.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("NOU_DESCOMPTE")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Nou descompte");
            menuItem.setUrl("/views/app/descompte/modificar_descompte.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
    	} else if (destinacio.equalsIgnoreCase("MODIFICAR_DESCOMPTE")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		Descompte descompte = new Descompte();
    		try{
    			descompte = descompteDAO.cercarPerId(params.get(2));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Modificar descompte: "+descompte.getNom());
            menuItem.setUrl("/views/app/funcio/modificar_funcio.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1)+"&idDescompteModificar="+params.get(2));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
         // PREUS LOCALITATS
    	} else if (destinacio.equalsIgnoreCase("PREUS_LOCALITATS")) {
    		Recinte recinte = new Recinte();
    		try{
    			recinte = recinteDAO.cercarPerId(params.get(0));
    		} catch (Exception e) {}
    		
    		Espectacle espectacle = new Espectacle();
    		try{
    			espectacle = espectacleDAO.cercarPerId(params.get(1));
    		} catch (Exception e) {}
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar recintes");
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
    		
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Recinte: "+recinte.getNom());
            menuItem.setUrl("/views/app/recinte/recintes.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Espectacle: "+espectacle.getNom());
            menuItem.setUrl("/views/app/espectacle/espectacles.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuItem = new DefaultMenuItem();
            menuItem.setValue("Gestionar preus localitats");
            menuItem.setUrl("/views/app/preuslocs/preuslocs.xhtml?faces-redirect=true&idRecinte="+params.get(0)+"&idEspectacle="+params.get(1));
            model.addElement(menuItem);
            
            menuActiu = "RECINTES";
        // ESTADÍSTIQUES
    	} else if (destinacio.equalsIgnoreCase("ESTADISTIQUES")) {
    		menuItem = new DefaultMenuItem();
            menuItem.setValue("Informes estadístics");
            menuItem.setUrl("/views/app/estadistiques/estadistiques.xhtml?faces-redirect=true");
            model.addElement(menuItem);
            
            menuActiu = "ESTADISTIQUES";
    	}
    }
    
    public MenuModel getModel() {
        return this.model;
    }
    
    public void setModel(MenuModel model) {
        this.model = model;
    }
    
    public String getMenuActiu() {
        return this.menuActiu;
    }
    
    public void setMenuActiu(String menuActiu) {
        this.menuActiu = menuActiu;
    }
    
}