package com.espectaclia.security;

import java.util.Collection;

import org.springframework.security.core.GrantedAuthority;

import com.espectaclia.entities.Usuari;

public class CustomUserDetails extends org.springframework.security.core.userdetails.User{

	private static final long serialVersionUID = 1L;
	
    private Usuari usuari;
    private String tipus;

    public CustomUserDetails(Usuari usuari, Collection<? extends GrantedAuthority> authorities) {
        super(usuari.getUsername(), usuari.getPassword(), authorities);
        this.usuari = usuari;
    }

    public CustomUserDetails(Usuari usuari, String tipus, boolean enabled, boolean accountNonExpired, boolean credentialsNonExpired, boolean accountNonLocked, Collection<? extends GrantedAuthority> authorities) {
        super(usuari.getUsername(), usuari.getPassword(), enabled, accountNonExpired, credentialsNonExpired, accountNonLocked, authorities);
        this.usuari = usuari;
        this.tipus = tipus;
    }

    public Usuari getUsuari() {
        return usuari;
    }
    
    public String getTipus() {
        return tipus;
    }
}