package com.espectaclia.services;

import com.espectaclia.entities.Localitat;
import com.espectaclia.daos.LocalitatDAO;

import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

@Component
@Transactional
public class LocalitatService extends EntityService<Localitat> implements LocalitatDAO {

	@Transactional
	public void eliminar(Localitat localitat) throws Exception{
		if (!getEntityManager().contains(localitat)){
		   localitat = getEntityManager().merge(localitat);
		}

		localitat.getZona().getLocalitats().remove(localitat);
		localitat.getReserva().getLocalitats().remove(localitat);

		getEntityManager().remove(localitat);
	};
	
}