package com.espectaclia.validators;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

@FacesValidator("nifValidator")
public class NIFValidator implements Validator {

	private static final String messageCloseButton = "<button type=\"button\" class=\"close\" onclick=\"$(this).parent().fadeOut()\"><span aria-hidden=\"true\">×</span></button>";
	
	@Override
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
	
		String nif = value.toString();
		
		if (nif == null || nif.isEmpty()) return;
		
		// Validació longitud y caràcters alfanumèrics
		if (nif.length() != 9 || !nif.trim().matches("\\p{Alnum}*")) {
			throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "El NIF ha d'estar format per 9 carácters alfanumèrics." + messageCloseButton, ""));
		}
		
		// Validació format
		if (!nif.trim().matches("[0-9]{8}[A-Z]")) {
			throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "El format del NIF no és correcte. Ha d'estar format per 8 números i 1 lletra." + messageCloseButton, ""));
		}
	
	}
}