package com.espectaclia.validators;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

@FacesValidator("numeracioLocsZonaValidator")
public class NumeracioLocsZonaValidator implements Validator {

	private static final String messageCloseButton = "<button type=\"button\" class=\"close\" onclick=\"$(this).parent().fadeOut()\"><span aria-hidden=\"true\">×</span></button>";
	
	@Override
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
	
		Integer numSeientsFila = Integer.parseInt(value.toString());
		
		UIInput uiInputNumFiles = (UIInput) component.getAttributes().get("numFiles");
		Integer numFiles = Integer.parseInt(uiInputNumFiles.getValue().toString());
		
		UIInput uiInputAforament = (UIInput) component.getAttributes().get("aforament");
		Integer aforament = Integer.parseInt(uiInputAforament.getValue().toString());
		
		// Si no ve algun dels 3 valors deixem actuar els "required"
		if (numFiles == null || numSeientsFila == null || aforament == null) return;
		
		// El producte de numFiles per numSeientsFila ha de ser igual a l'aforament
		if (numFiles * numSeientsFila != aforament) {
			uiInputNumFiles.setValid(false);
			throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "El producte del nº de files pel nº de seients per fila ha de ser igual a l'aforament." + messageCloseButton, ""));
		}
	
	}
}