package com.espectaclia.validators;

import java.util.Date;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

@FacesValidator("rangDatesValidator")
public class RangDatesValidator implements Validator {

	private static final String messageCloseButton = "<button type=\"button\" class=\"close\" onclick=\"$(this).parent().fadeOut()\"><span aria-hidden=\"true\">×</span></button>";
	
	@Override
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
	
		Date dataFi = (Date) value;
		
		UIInput uiInputDataInici = (UIInput) component.getAttributes().get("dataInici");
		Date dataInici = (Date) uiInputDataInici.getValue();
		
		if (dataInici == null || dataFi == null) return;
		
		// dataInici ha de ser inferior a dataFi
		if (dataInici.after(dataFi)) {
			uiInputDataInici.setValid(false);
			throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "La data d'inici ha de ser inferior a la data de fi." + messageCloseButton, ""));
		}
	
	}
}