package com.espectaclia.validators;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

@FacesValidator("telefonValidator")
public class TelefonValidator implements Validator {

	private static final String messageCloseButton = "<button type=\"button\" class=\"close\" onclick=\"$(this).parent().fadeOut()\"><span aria-hidden=\"true\">×</span></button>";
	
	@Override
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
	
		String telefon = value.toString();
		
		if (telefon == null || telefon.isEmpty()) return;
		
		// Validació és un número
		try {
	        Long.parseLong(telefon);
	    } catch (NumberFormatException nfe) {
	    	throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "El telèfon no pot contenir caràcters que no siguin números." + messageCloseButton, ""));
	    }
		
		// Validació longitud
		if (telefon.length() != 9) {
			throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "El telèfon ha d'estar format per 9 números sense espais." + messageCloseButton, ""));
		}
	
	}
}
